package core

import (
	"strings"

	"git.akyoto.dev/cli/q/src/types"
)

// TypeByName returns the type with the given name or `nil` if it doesn't exist.
func (f *Function) TypeByName(name string) types.Type {
	if strings.HasPrefix(name, "*") {
		to := strings.TrimPrefix(name, "*")
		return &types.Pointer{To: f.TypeByName(to)}
	}

	return f.Types[name]
}
