package types

var PointerAny = &Pointer{To: nil}

// Pointer is the address of an object.
type Pointer struct {
	To Type
}

// Name returns the type name.
func (p *Pointer) Name() string {
	if p.To == nil {
		return "Pointer"
	}

	return "Pointer:" + p.To.Name()
}

// Size returns the total size in bytes.
func (p *Pointer) Size() int {
	return 8
}
